`timescale 1ns/1ns
`define timeperiod 20

module DAC_tb();
	
	reg clk,rst_n;
	reg START;
	reg [15:0] DAC_DATA;
	
	wire CS_N;
	wire SCLK;
	wire DIN;
	wire DAC_STATE;
	
	
	DAC_driver DAC_driver(
	.clk		(clk),
	.rst_n		(rst_n),
	.START		(START),
	.DAC_DATA	(DAC_DATA),
                 
	.CS_N		(CS_N),
	.SCLK		(SCLK),
	.DIN		(DIN),
	.DAC_STATE	(DAC_STATE)
);

	initial clk = 1'b0;
	always #(`timeperiod / 2) clk = ~clk;
	
	initial begin
		rst_n = 1'b0;
		#(`timeperiod * 10);
		rst_n = 1'b1;
		#(`timeperiod * 20);
		
		DAC_DATA = 16'hC_AAA;
		START = 1;
		#20;
		START = 0;
		#200;
		wait(!DAC_STATE);
		
		#2000;
		
		DAC_DATA = 16'h4_555;
		START = 1;
		#20;
		START = 0;
		#200;
		wait(!DAC_STATE);
	
		#2000;
		
		#2000;
		$stop;
	
	end 
endmodule