module DAC_top(
	clk,
	rst_n,
	key,
	
	DIN,
	CS_N,
	SCLK
);

	input clk,rst_n;
	input key;
	
	output wire DIN;
	output wire CS_N;
	output wire SCLK;
	
	
	wire [15:0] DAC_DATA;
	wire DAC_STATE;

	reg START;
	
	DAC_driver DAC_driver(
		.clk		(clk),
		.rst_n		(rst_n),
		.START		(START),
		.DAC_DATA	(DAC_DATA),
	
		.CS_N		(CS_N),
		.SCLK		(SCLK),
		.DIN		(DIN),
		.DAC_STATE	(DAC_STATE)
);



	DAC DAC_test (
		.probe		(DAC_DATA[11:0]),  //  probes.probe
		.source		(DAC_DATA)  // sources.source
);

	
	
	reg [15:0] DAC_DATA_r;
	always@ (posedge clk or negedge rst_n)
		if(!rst_n)
			DAC_DATA_r <= 16'd0;
		else if (DAC_STATE)
				DAC_DATA_r <= DAC_DATA;
			else
				DAC_DATA_r <= DAC_DATA_r;
	
	
	always@ (posedge clk or negedge rst_n)
		if(!rst_n)
			START <= 1'b0;
		else if (DAC_DATA_r != DAC_DATA)
				START <= 1'b1;
			else
				START <= 1'b0;
				
				
				
endmodule 		
